apcmat <-
function(a, p, ref=c(0,0,0) ) {
  ## matrix for APC model, see Fu (2016)
  alpha = diag(rep(1, a))
  if (ref[1] == 0)  
    alpha <- rbind(diag(rep(1, a - 1)), rep(-1, a - 1))
  if ((ref[1] > 0) && ref[1] < a+1)
    alpha <- alpha[,-ref[1]]
  
  beta <- diag(rep(1, p))
  if (ref[2] == 0)  
    beta <- rbind(diag(rep(1, p - 1)), rep(-1, p - 1))
  if ((ref[2] > 0) && (ref[2] < p+1))
    beta <- beta [, -ref[2]]
    
  gammaa = diag(rep(1, a + p - 1))
  if (ref[3] == 0)
    gammaa <- rbind(diag(rep(1, a + p - 2)), rep(-1, a + p - 2))
  if ((ref[3] > 0) && (ref[3] < a+p))
    gammaa = gammaa [,-ref[3]]
  
    x <- rep(0, 2 * (a + p) - 3 ) 
  for(i in 1:a) {
    for(j in 1:p) {
      rr <- c(1, alpha[i,  ], beta[j,  ], gammaa[a - i + j,  ])
      x <- rbind(x, rr)
    }
  }
  x <- x[-1,  ]
  return(x)
}
